--- old/usr/src/cmd/perl/skel/Makefile	2014-01-29 21:01:32.105027773 +0000
+++ new/usr/src/cmd/perl/skel/Makefile	2014-01-29 21:01:32.117376465 +0000
@@ -20,6 +20,7 @@
 #
 #
 # Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2013 Racktop Systems.
 #
 
 include ../../Makefile.cmd
@@ -33,12 +34,25 @@
 
 PERL=/usr/perl5/$(PERL_VERSION)/bin/perl
 
-PERL_MM_ARGS = INSTALLDIRS=perl CC='$(CC)' LD='$(CC)'
+PERL_MM_ARGS = CC='$(CC)' LD='$(CC)'
 
 # Prefix for Solaris-specific extensions that are maintained by
 # Sun/Oracle.
 SUN_SOLARIS = Sun/Solaris
 
+# When building with gcc we don't bother with cw.  Intead we use PerlGcc to
+# make sure the Makefile contains options that the compiler will understand.
+# The version on the host could be incomplete so use the one we're building.
+PERL5LIB =
+$(__GNUC)PERL5LIB= \
+    $(SRC)/cmd/perl/$(PERL_VERSION)/$(SUN_SOLARIS)/PerlGcc
+
+$(__GNUC)PERL_MM_ARGS = \
+    CC='$(GCC_ROOT)/bin/gcc' \
+    LD='$(GCC_ROOT)/bin/gcc'
+
+PERL_MM_ARGS += INSTALLDIRS=perl
+
 # Add any XS extensions here.
 PERL_DYNAMIC_EXT = \
     $(SUN_SOLARIS)/Utils \
@@ -60,6 +74,9 @@
 PERL_EXT = $(PERL_DYNAMIC_EXT) $(PERL_NONXS_EXT)
 PERL_EXT_MAKEFILES = $(PERL_EXT:%=%/Makefile)
 
+# When doing a gcc build we need to build PerGcc before the dynamic extenions.
+$(__GNUC)$(PERL_DYNAMIC_EXT:%=%/Makefile): $(SUN_SOLARIS)/PerlGcc/Makefile
+
 all: copy_contrib $(PERL_EXT_MAKEFILES) $(PERL_EXT)
 
 .PARALLEL: $(PERL_EXT_MAKEFILES) $(PERL_EXT)
@@ -114,7 +131,8 @@
 # trying to build the extension
 #
 %/Makefile: %/Makefile.PL $(PERL_CONFIGDEP)
-	@ cd $(@D); pwd; $(PERL) $(<F) $(PERL_MM_ARGS) 2>&1 /dev/null
+	@ cd $(@D); pwd; PERL5LIB=$(PERL5LIB) \
+		$(PERL) $(<F) $(PERL_MM_ARGS) 2>&1 /dev/null
 
 # Pattern-matching rule for extensions.
 $(SUN_SOLARIS)/%: $(SUN_SOLARIS)/%/Makefile FRC
